<?php

/*
Plugin Name: WP-UserLogin Widget
Plugin URI: http://wayofthegeek.org/downloads/wp-userlogin/
Description: Adds a UserLogin Widget to display login form or dashboard links depending on login status.
Version: 4.0
Author: Jerry Stephens
Author URI: http://wayofthegeek.org/
*/


/*  
	Copyright 2007  Jerry Stephens  (email : migo@wayofthegeek.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
$plugin_dir = basename(dirname(__FILE__));
load_plugin_textdomain( 'wp-userlogin', 'wp-content/plugins/' . $plugin_dir, $plugin_dir );

add_action('admin_menu','option_page');

function option_page(){
	add_theme_page(__('UserLogin', 'wp-userlogin'),__('UserLogin Options', 'wp-userlogin'),10,__FILE__,'userlogin_options');	
}

function userlogin_options(){
	        
	$newvalue = "";
	$autoload = "yes";
	$deprecated = " ";
	$boxvalue = array('CHECKED','CHECKED','CHECKED','CHECKED','CHECKED','CHECKED','CHECKED','CHECKED','CHECKED');
	$option = array('set_nonlog','set_log','redirect','redirect_out','set_checkbox','welcome');
	add_option($option[0],"Login",$deprecated,$autoload);
	add_option($option[1],"Control Panel",$deprecated,$autoload);
	add_option($option[2],'',$deprecated,$autoload);
	add_option($option[3],'',$deprecated,$autoload);
	add_option('set_checkbox',$boxvalue,$deprecated,$autoload);
        add_option($option[4], "Welcome back, %user",$deprecated,$autoload);
	$check = get_option('set_checkbox');
	$redirect = get_option('redirect');
	$redirect_out = get_option('redirect_out');
        $welcome = get_option('welcome');
?>
		<div class="wrap">
		<h2><?php _e('UserLogin Options', 'wp-userlogin');?></h2>
	<form method="post" action="options.php">
	<?php wp_nonce_field('update-options'); ?>
	<table><tr><td valign="top" width="250px">
		<h3 style="margin: 0;"><?php _e('Login Form Title', 'wp-userlogin');?>:</h3>
		<input type="text" name="set_nonlog" size="15" value="<?php echo get_option($option[0]); ?>" />
		<h3 style="margin: 0;"><?php _e('Control Panel Title', 'wp-userlogin');?>:</h3>
		<input type="text" name="set_log" size="15" value="<?php echo get_option($option[1]); ?>" />
		<h3 style="margin: 0;"><?php _e('Redirect Page', 'wp-userlogin');?>:</h3>
		<input type="text" name="redirect" size="15" value="<?php echo $redirect; ?>" /><br />
		<small><?php  _e('Please use absolute URL<br />(redirects to a page after successful login)', 'wp-userlogin');?></small>
		<h3 style="margin: 0;"><?php _e('Logout Redirect', 'wp-userlogin');?>:</h3>
		<input type="text" name="redirect_out" size="15" value="<?php echo $redirect_out; ?>" /><br />
		<small><?php  _e('Please use absolute URL<br />(redirects to a page after logout)', 'wp-userlogin');?></small>

	</td>
	<td valign="top">
	
	<h3 style="margin: 0;"><?php _e('Available Links (based on user role)', 'wp-userlogin'); ?>:</h3>
	<input type="checkbox" name="set_checkbox[0]" value="CHECKED" <?php echo $check[0]; ?> /> <?php _e('Dashboard');?><br />
	<input type="checkbox" name="set_checkbox[1]" value="CHECKED" <?php echo $check[1]; ?> /> <?php _e('New Post');?><br />
	<input type="checkbox" name="set_checkbox[2]" value="CHECKED" <?php echo $check[2]; ?> /> <?php _e('Edit Posts');?><br />
	<input type="checkbox" name="set_checkbox[3]" value="CHECKED" <?php echo $check[3]; ?> /> <?php _e('Manage Themes');?><br />
	<input type="checkbox" name="set_checkbox[4]" value="CHECKED" <?php echo $check[4]; ?> /> <?php _e('Options');?><br />
	<input type="checkbox" name="set_checkbox[5]" value="CHECKED" <?php echo $check[5]; ?> /> <?php _e('Users');?><br />
	<input type="checkbox" name="set_checkbox[6]" value="CHECKED" <?php echo $check[6]; ?> /> <?php _e('Your Profile');?><br />
	<input type="checkbox" name="set_checkbox[7]" value="CHECKED" <?php echo $check[7]; ?> /> <?php _e('Logout');?><br />

	</td></tr>
        <tr><td colspan="2">
                        <h3><?php _e('Welcome User', 'wp-userlogin');?></h3>
<table><tr><td valign="top">
                <?php _e('Welcome Message', 'wp-userlogin');?>:<br />
                <input type="text" name="welcome" size="25" value="<?php echo $welcome; ?>" />

<br />
                <input type="checkbox" name="set_checkbox[8]" value="CHECKED" <?php echo $check[8]; ?> /> <?php _e('Display Welcome Message', 'wp-userlogin');?><br />
</td><td valign="top" style="padding-left: 10px;">
            <dt><strong><small><?php _e('indicate current user with', 'wp-userlogin');?></small>:</strong>
            <table>
                <tr><td><dd><strong>%user</strong> </td><td>&rarr;</td><td> <?php _e('Display Name');?> </dd></td></tr>
                <tr><td><dd><strong>%login</strong> </td><td>&rarr;</td><td> <?php _e('Username/Login');?></dd></td></tr>
                <tr><td><dd><strong>%id</strong> </td><td>&rarr;</td><td> <?php _e('User ID');?></dd></td></tr>
                <tr><td><dd><strong>%email</strong> </td><td>&rarr;</td><td> <?php _e('User Email');?></dd></td></tr>
                <tr><td><dd><strong>%firstname</strong> </td><td>&rarr;</td><td> <?php _e('User First Name');?> (defaults to Display Name if blank)</dd></td></tr>
                <tr><td><dd><strong>%lastname</strong> </td><td>&rarr;</td><td> <?php _e('User Last Name');?> (defaults to Display Name if blank)</dd></td></tr>
                <tr><td><dd><strong>%fullname</strong> </td><td>&rarr;</td><td> <?php _e('User Full Name');?> (defaults to Display Name if blank)</dd></td></tr>
            </table>
           </dt>
</td></tr></table>
                
                </td></tr>
</table>
	<input type="hidden" name="action" value="update" />
	<input type="hidden" name="page_options" value="set_nonlog,set_log,redirect,redirect_out,set_checkbox,welcome" />
	<p class="submit">
		<input type="submit" name="Submit" value="<?php _e('Save Changes')?> " />
	</p>
<?php
}

function initial_db($args){
	$newvalue = "";
	$autoload = "yes";
	$deprecated = " ";
	$boxvalue = array('CHECKED','CHECKED','CHECKED','CHECKED','CHECKED','CHECKED','CHECKED','CHECKED','CHECKED');
	$option = array('set_nonlog','set_log','redirect','set_checkbox');
	add_option($option[0],"Login",$deprecated,$autoload);
	add_option($option[1],"Control Panel",$deprecated,$autoload);
	add_option($option[2],'',$deprecated,$autoload);
	add_option('set_checkbox',$boxvalue,$deprecated,$autoload);
	$check = get_option('set_checkbox');
	$redirect = get_option('redirect');
        $redirect_out = get_option('redirect_out');
        $welcome = get_option('welcome');
}

function widget_userlogin_init() {
	if (!function_exists('register_sidebar_widget')) {
        return;
	}

###Function: User Permissions
function user_permissions($args){
	$wp_url = get_settings('siteurl');
	$check = get_option('set_checkbox');
        $welcome = get_option('welcome');
        $redirect_out = get_option('redirect_out');
	$vals = explode(',',$args);
        global $current_user, $user_ID;
        get_currentuserinfo();	
	foreach($vals as $val)	{
	
	if($check[0] == "CHECKED" && $val == "0"){
		$link[0] = '<li><a href="'.$wp_url.'/wp-admin/">'.__('Dashboard').'</a></li>';
	}
	if($check[1] == "CHECKED" && $val == "1"){
$link[1]= '<li><a href="'.$wp_url.'/wp-admin/post-new.php">'.__('New Post').'</a></li>';
	}
	if($check[2] == "CHECKED" && $val == "2"){
$link[2]= '<li><a href="'.$wp_url.'/wp-admin/edit.php">'.__('Edit Posts').'</a></li>';
	}
	if($check[3] == "CHECKED" && $val == "3"){
$link[3]= '<li><a href="'.$wp_url.'/wp-admin/themes.php">'.__('Manage Theme').'</a></li>';
	}
	if($check[4] == "CHECKED" && $val == "4"){
$link[4]= '<li><a href="'.$wp_url.'/wp-admin/options-general.php">'.__('Options').'</a></li>';
	}
	if($check[5] == "CHECKED" && $val == "5"){
$link[5]= '<li><a href="'.$wp_url.'/wp-admin/users.php">'.__('Users').'</a></li>';
	}
	if($check[6] == "CHECKED" && $val == "6"){
$link[6]= '<li><a href="'.$wp_url.'/wp-admin/profile.php">'.__('Your Profile').'</a></li>'.PHP_EOL.
'<li><a href="'.$wp_url.'/?author='.$user_ID.'">'.__('View Your Profile','wp-userlogin').'</a></li>';
	}
	if($check[7] == "CHECKED" && $val == "7"){
$link[7]='<li><a href="'.wp_logout_url($redirect_out).'">'.__('Logout').'</a></li>';	
	}
 	}
 	
    if($check[8] == "CHECKED"){
        if($current_user->user_firstname != "") :
            $firstname = $current_user->user_firstname;
        else: 
            $firstname = $current_user->display_name;
        endif;

        if($current_user->user_lastname != ""):
            $lastname = $current_user->user_lastname;
        else: 
            $lastname = $current_user->display_name;
        endif;
        
        if($current_user->user_firstname != "" && $current_user->user_lastname != ""):
            $fullname = $current_user->user_firstname.' '.$current_user->user_lastname;
        else :
            $fullname = $current_user->display_name;
        endif;
        
        $head = preg_replace('/\%user/',$current_user->display_name,
        preg_replace('/\%login/',$current_user->user_login,
        preg_replace('/\%id/',$current_user->ID,
        preg_replace('/\%email/',$current_user->user_email,
        preg_replace('/\%firstname/',$firstname,
        preg_replace('/\%lastname/',$lastname,
        preg_replace('/\%fullname/',$fullname,$welcome)))))));

    }
    else{ 
        $head = '';
    }	
 	
        $head = $head . '<ul class="menu">';
        
 	$foot =  "</ul>";
$links = implode('',$link);
	return $head.$links.$foot;
}

###Function: UserLogin Widget
function widget_userlogin($args) {
  extract($args);
	$wp_url = get_settings('siteurl');

	echo $before_widget
		.'<a name="login"></a>';
	global $user_ID, $user_identity, $user_level;
 //If user ID is present print out the options
	if (is_user_logged_in() ) {
		$title = get_option('set_log');	
	
	if ( $user_level >= 8 ){
		$options = user_permissions('0,1,2,3,4,5,6,7');
	}
	
	elseif( $user_level >= 5 && $user_level < 8 ){
		$options = user_permissions('0,1,2,5,6,7');
	}
		
	elseif( $user_level >= 1 && $user_level < 5 ){
		$options = user_permissions('0,1,6,7');
	}
	
	elseif($user_level == 0 ){
		$options = user_permissions('0,6,7');
	}
}		

//If no user ID is present show registration link and login form
	else {
		$title = get_option('set_nonlog');


		if(get_option('redirect') != ""){
			$redir = get_option('redirect');
		}
		else{
                        $redir = $_SERVER['REQUEST_URI'];
		}

		$form = "<form name=\"loginform\" id=\"loginform\" action=\"".wp_login_url($redir) ."\" method=\"post\">
                                    <label for=\"log\">".__('Username')."<br /><input type=\"text\" name=\"log\" id=\"log\" value=\"".  wp_specialchars(stripslashes($user_login), 1) ."\" /></label><br />
				<label for=\"pwd\">".__('Password')."<br /><input type=\"password\" name=\"pwd\" id=\"pwd\" /></label><br />\n";

//If WP-OpenID plugin is found active show OpenID login field
// WP-OpenID plugin can be found at (http://wordpress.org/extend/plugins/openid/)
	if(function_exists('openid_input')){
        $openid = '<label for="openid">'.__('OpenID', 'wp-userlogin').'<br />'.openid_input().'</label><br />';
	}
	else{
	$openid = "";
	}
	
//Build Submit button, Remember Me box, and links for registations and forgotten password
	$remember = "<label for=\"rememberme\"><input name=\"rememberme\" id=\"rememberme\" type=\"checkbox\" checked=\"checked\" value=\"forever\" /> ".__('Remember Me')."</label><br />
	<input type=\"submit\" name=\"submit\" value=\"".__('Log in')."\" class=\"button\" />
				</form><br />";
	if(get_option('users_can_register')) {
		$register =  "\n<a href=\"". $wp_url ."/wp-login.php?action=register\">".__('Register')."</a>";
	}
	
	else{
		$register = "";
	}
	
	$recover = "\n<a href=\"".wp_lostpassword_url( $_SERVER['REQUEST_URI'] )."\">".__('Lost your password?')."</a>";
	
	$submit = $remember.$register.$recover;

//Cobble the form, OpenID option, and submission together
$options = $form.$openid.$submit;
	}

//Build widget based on login status and user role
		echo $before_title
		. $title
		. $after_title
		. $options;


get_option('users_can_register');

	echo $after_widget;
}
//Register Sidebar Widget
register_sidebar_widget('User Login','widget_userlogin');		
}
### Function: Load the DB info on activation
register_activation_hook( __FILE__, 'initial_db' );
### Function: Load The WP-UserLogin Widget
add_action('plugins_loaded', 'widget_userlogin_init');

?>